class Normalize:
    def __init__(self,board,fen_given):
        self.board = board
        self.fen_given = fen_given
        self.Correspondance = {'black-pawn':'p', 'black-rook':'r','black-knight':'n','black-bishop':'b','black-king':'k','black-queen':'q','white-pawn':'P', 'white-rook':'R','white-knight':'N','white-bishop':'B','white-king':'K','white-queen':'Q'}
        self.fen = self._get_fen_from_board()
        self.board_extracted = self._make_board_from_fen()

    def _get_fen_from_board(self):
        fen = ''
        for row in range(8):
            col = 0
            i=0
            while col<8:
                if self.board[row][col]:
                    if i>0:
                        fen+=str(i)
                    fen+=self.Correspondance[self.board[row][col]]
                    i=0

                elif not self.board[row][col] and col<7:
                        i+=1
                else:
                     fen+=str(i+1)
                col+=1
            fen +='/'
        return fen

    def _make_board_from_fen(self):
        board =[]
        row = []
        for letter in self.fen_given:
            if letter == '/':
                board.append(row)
                row = []

            elif letter not in self.Correspondance.values():
                for k in range(int(letter)):
                    row.append(None)
                    
            else:
                for k,v in self.Correspondance.items():
                    if v==letter:
                        row.append(k)
        board.append(row)
        return board
                

            
             
        
