class Pawn:
    def __init__(self,color,position,board):
        self.color = color
        self.position = position
        self.board = board
        
    def find_moves(self):

        self.valid_moves = []
        if self.color == 'black':
            #poussée 
            if self.position[0] == 7:
                return []
            
            if self.position[0] ==1:
                if not self.board[2][self.position[1]]:
                    self.valid_moves.append((2,self.position[1]))
                    if not self.board[3][self.position[1]]:
                        self.valid_moves.append((3,self.position[1]))
                    
            else:
                if not self.board[self.position[0]+1][self.position[1]]:
                    self.valid_moves.append((self.position[0]+1,self.position[1]))
            #capture
            if self.position[0]+1<8:
                if self.position[1]+1<8:
                    if self.board[self.position[0]+1][self.position[1]+1]:
                        color = self.board[self.position[0]+1][self.position[1]+1][0:5]
                        if color !=self.color:
                            self.valid_moves.append((self.position[0]+1,self.position[1]+1))

                if self.position[1]-1>=0:
                    if self.board[self.position[0]+1][self.position[1]-1]:
                        color = self.board[self.position[0]+1][self.position[1]-1][0:5]
                        if color !=self.color:
                            self.valid_moves.append((self.position[0]+1,self.position[1]-1))
            
        else:
            #pousée
            if self.position[0] == 0:
                return []
            if self.position[0] ==6:
                if not self.board[5][self.position[1]]:
                    self.valid_moves.append((5,self.position[1]))
                    if not self.board[4][self.position[1]]:
                        self.valid_moves.append((4,self.position[1]))

            else:
                if not self.board[self.position[0]-1][self.position[1]]:
                    self.valid_moves.append((self.position[0]-1,self.position[1]))

            #capture
            if self.position[0]-1>=0:
                if self.position[1]+1<8:
                    if self.board[self.position[0]-1][self.position[1]+1]:
                        color = self.board[self.position[0]-1][self.position[1]+1][0:5]
                        if color !=self.color:
                            self.valid_moves.append((self.position[0]-1,self.position[1]+1))

                if self.position[1]-1>=0:
                    if self.board[self.position[0]-1][self.position[1]-1]:
                        color = self.board[self.position[0]-1][self.position[1]-1][0:5]
                        if color !=self.color:
                            self.valid_moves.append((self.position[0]-1,self.position[1]-1))
            
        return self.valid_moves
        

class Rook:
    def __init__(self,color,position,board):
        self.position = position
        self.board = board
        self.color = color

    def find_moves(self):
        valid_moves = []

        #droite
        for lateral in range(self.position[1]+1,8):
            if self.board[self.position[0]][lateral]:#il y a une pièce
                color = self.board[self.position[0]][lateral][0:5]
                if color == self.color:#pièce alliée sur la case
                    break
                else:
                    valid_moves.append((self.position[0],lateral))
                    break
            else:
                valid_moves.append((self.position[0],lateral))

        #gauche
        for lateral in range(self.position[1]-1,-1,-1):
            if self.board[self.position[0]][lateral]:#il y a une pièce
                color = self.board[self.position[0]][lateral][0:5]
                if color == self.color:#pièce alliée sur la case
                    break
                else:
                    valid_moves.append((self.position[0],lateral))
                    break
            else:
                valid_moves.append((self.position[0],lateral))

        #bas
        for lateral in range(self.position[0]+1,8):
            if self.board[lateral][self.position[1]]:#il y a une pièce
                color = self.board[lateral][self.position[1]][0:5]
                if color == self.color:#pièce alliée sur la case
                    break
                else:
                    valid_moves.append((lateral,self.position[1]))
                    break
            else:
                valid_moves.append((lateral,self.position[1]))


        #haut
        for lateral in range(self.position[0]-1,-1,-1):
            if self.board[lateral][self.position[1]]:#il y a une pièce
                color = self.board[lateral][self.position[1]][0:5]
                if color == self.color:#pièce alliée sur la case
                    break
                else:
                    valid_moves.append((lateral,self.position[1]))
                    break
            else:
                valid_moves.append((lateral,self.position[1]))

        return valid_moves
        

class Bishop:
    def __init__(self,color, position,board):
        self.position = position
        self.board = board
        self.color = color 

    def find_moves(self):
        self.valid_moves = []
        #haut-droite
        move_up = 0
        for move in range(self.position[0]-1,-1,-1):
            
            move_up+=1
            if move_up+self.position[1]>=8:
                break
            if self.board[move][self.position[1]+move_up]:#il y a une pièce
                color = self.board[move][self.position[1]+move_up][0:5]
                if color == self.color:
                    break
                else:
                    self.valid_moves.append((move,self.position[1]+move_up))
                    break

            else:
                self.valid_moves.append((move,self.position[1]+move_up))

        #haut-gauche
        move_up = 0
        for move in range(self.position[0]-1,-1,-1):
            
            move_up+=1
            if self.position[1]-move_up<0:
                break
            if self.board[move][self.position[1]-move_up]:#il y a une pièce
                color = self.board[move][self.position[1]-move_up][0:5]
                if color == self.color:
                    break
                else:
                    self.valid_moves.append((move,self.position[1]-move_up))
                    break

            else:
                self.valid_moves.append((move,self.position[1]-move_up))

        #bas-gauche
        move_down = 0
        for move in range(self.position[0]+1,8):
            
            move_down+=1
            if self.position[1]-move_down<0:
                break
            if self.board[move][self.position[1]-move_down]:#il y a une pièce
                color = self.board[move][self.position[1]-move_down][0:5]
                if color == self.color:
                    break
                else:
                    self.valid_moves.append((move,self.position[1]-move_down))
                    break

            else:
                self.valid_moves.append((move,self.position[1]-move_down))

        #bas-droite
        move_down = 0
        for move in range(self.position[0]+1,8):
            
            move_down+=1
            if self.position[1]+move_down>7:
                break
            if self.board[move][self.position[1]+move_down]:#il y a une pièce
                color = self.board[move][self.position[1]+move_down][0:5]
                if color == self.color:
                    break
                else:
                    self.valid_moves.append((move,self.position[1]+move_down))
                    break

            else:
                self.valid_moves.append((move,self.position[1]+move_down))



        return self.valid_moves

    
class Knight:
    def __init__(self,color,position,board):
        self.position = position
        self.board = board
        self.color = color

    def find_moves(self):
        self.valid_moves = []
        #bas

        if self.position[0]+1<8:
            if self.position[1]+2<8:
                if self.board[self.position[0]+1][self.position[1]+2]:
                    color = self.board[self.position[0]+1][self.position[1]+2][0:5]
                    if color != self.color:
                        self.valid_moves.append((self.position[0]+1,self.position[1]+2))
                else:
                    self.valid_moves.append((self.position[0]+1,self.position[1]+2))

        if self.position[0]+1<8:
            if self.position[1]-2>=0:
                if self.board[self.position[0]+1][self.position[1]-2]:
                    color = self.board[self.position[0]+1][self.position[1]-2][0:5]
                    if color != self.color:
                        self.valid_moves.append((self.position[0]+1,self.position[1]-2))
                else:
                    self.valid_moves.append((self.position[0]+1,self.position[1]-2))

        if self.position[0]+2<8:
            if self.position[1]+1<8:
                if self.board[self.position[0]+2][self.position[1]+1]:
                    color = self.board[self.position[0]+2][self.position[1]+1][0:5]
                    if color != self.color:
                        self.valid_moves.append((self.position[0]+2,self.position[1]+1))
                else:
                    self.valid_moves.append((self.position[0]+2,self.position[1]+1))

        if self.position[0]+2<8:
            if self.position[1]-1>=0:
                if self.board[self.position[0]+2][self.position[1]-1]:
                    color = self.board[self.position[0]+2][self.position[1]-1][0:5]
                    if color != self.color:
                        self.valid_moves.append((self.position[0]+2,self.position[1]-1))
                else:
                    self.valid_moves.append((self.position[0]+2,self.position[1]-1))
        #haut

        if self.position[0]-1>=0:
            if self.position[1]+2<8:
                if self.board[self.position[0]-1][self.position[1]+2]:
                    color = self.board[self.position[0]-1][self.position[1]+2][0:5]
                    if color != self.color:
                        self.valid_moves.append((self.position[0]-1,self.position[1]+2))
                else:
                    self.valid_moves.append((self.position[0]-1,self.position[1]+2))

        if self.position[0]-1>=0:
            if self.position[1]-2>=0:
                if self.board[self.position[0]-1][self.position[1]-2]:
                    color = self.board[self.position[0]-1][self.position[1]-2][0:5]
                    if color != self.color:
                        self.valid_moves.append((self.position[0]-1,self.position[1]-2))
                else:
                    self.valid_moves.append((self.position[0]-1,self.position[1]-2))

        if self.position[0]-2>=0:
            if self.position[1]+1<8:
                if self.board[self.position[0]-2][self.position[1]+1]:
                    color = self.board[self.position[0]-2][self.position[1]+1][0:5]
                    if color != self.color:
                        self.valid_moves.append((self.position[0]-2,self.position[1]+1))
                else:
                    self.valid_moves.append((self.position[0]-2,self.position[1]+1))

        if self.position[0]-2>=0:
            if self.position[1]-1>=0:
                if self.board[self.position[0]-2][self.position[1]-1]:
                    color = self.board[self.position[0]-2][self.position[1]-1][0:5]
                    if color != self.color:
                        self.valid_moves.append((self.position[0]-2,self.position[1]-1))
                else:
                    self.valid_moves.append((self.position[0]-2,self.position[1]-1))
            
        return self.valid_moves
        
       
class Queen:
    def __init__(self,color,position,board):
        self.position = position
        self.board = board
        self.color = color

    def find_moves(self):
        self.valid_moves = []

        #droite
        for lateral in range(self.position[1]+1,8):
            if self.board[self.position[0]][lateral]:#il y a une pièce
                color = self.board[self.position[0]][lateral][0:5]
                if color == self.color:#pièce alliée sur la case
                    break
                else:
                    self.valid_moves.append((self.position[0],lateral))
                    break
            else:
                self.valid_moves.append((self.position[0],lateral))

        #gauche
        for lateral in range(self.position[1]-1,-1,-1):
            if self.board[self.position[0]][lateral]:#il y a une pièce
                color = self.board[self.position[0]][lateral][0:5]
                if color == self.color:#pièce alliée sur la case
                    break
                else:
                    self.valid_moves.append((self.position[0],lateral))
                    break
            else:
                self.valid_moves.append((self.position[0],lateral))

        #bas
        for lateral in range(self.position[0]+1,8):
            if self.board[lateral][self.position[1]]:#il y a une pièce
                color = self.board[lateral][self.position[1]][0:5]
                if color == self.color:#pièce alliée sur la case
                    break
                else:
                    self.valid_moves.append((lateral,self.position[1]))
                    break
            else:
                self.valid_moves.append((lateral,self.position[1]))


        #haut
        for lateral in range(self.position[0]-1,-1,-1):
            if self.board[lateral][self.position[1]]:#il y a une pièce
                color = self.board[lateral][self.position[1]][0:5]
                if color == self.color:#pièce alliée sur la case
                    break
                else:
                    self.valid_moves.append((lateral,self.position[1]))
                    break
            else:
                self.valid_moves.append((lateral,self.position[1]))
        
        move_up = 0
        for move in range(self.position[0]-1,-1,-1):
            
            move_up+=1
            if move_up+self.position[1]>=8:
                break
            if self.board[move][self.position[1]+move_up]:#il y a une pièce
                color = self.board[move][self.position[1]+move_up][0:5]
                if color == self.color:
                    break
                else:
                    self.valid_moves.append((move,self.position[1]+move_up))
                    break

            else:
                self.valid_moves.append((move,self.position[1]+move_up))

        #haut-gauche
        move_up = 0
        for move in range(self.position[0]-1,-1,-1):
            
            move_up+=1
            if self.position[1]-move_up<0:
                break
            if self.board[move][self.position[1]-move_up]:#il y a une pièce
                color = self.board[move][self.position[1]-move_up][0:5]
                if color == self.color:
                    break
                else:
                    self.valid_moves.append((move,self.position[1]-move_up))
                    break

            else:
                self.valid_moves.append((move,self.position[1]-move_up))

        #bas-gauche
        move_down = 0
        for move in range(self.position[0]+1,8):
            
            move_down+=1
            if self.position[1]-move_down<0:
                break
            if self.board[move][self.position[1]-move_down]:#il y a une pièce
                color = self.board[move][self.position[1]-move_down][0:5]
                if color == self.color:
                    break
                else:
                    self.valid_moves.append((move,self.position[1]-move_down))
                    break

            else:
                self.valid_moves.append((move,self.position[1]-move_down))

        #bas-droite
        move_down = 0
        for move in range(self.position[0]+1,8):
            
            move_down+=1
            if self.position[1]+move_down>7:
                break
            if self.board[move][self.position[1]+move_down]:#il y a une pièce
                color = self.board[move][self.position[1]+move_down][0:5]
                if color == self.color:
                    break
                else:
                    self.valid_moves.append((move,self.position[1]+move_down))
                    break

            else:
                self.valid_moves.append((move,self.position[1]+move_down))
        

        return self.valid_moves
    

class King:
    def __init__(self,color,position,board):
        self.position = position
        self.board = board
        self.color = color 
        

    def find_moves(self):
        valid_moves = []
        for n in range(-1,2):
            for p in range(-1,2):
                if n ==0 and p==0:
                    continue
                else:
                    if self.position[0]+n<8 and self.position[0]+n>=0 and self.position[1]+p<8 and self.position[1]+p>=0:
                        if self.board[self.position[0]+n][self.position[1]+p]:
                            color = self.board[self.position[0]+n][self.position[1]+p][0:5]
                            if color != self.color:
                                valid_moves.append((self.position[0]+n,self.position[1]+p))
                        else:
                            valid_moves.append((self.position[0]+n,self.position[1]+p))

        return valid_moves
